
#include <stdio.h>
#include "str.h"

int main( int argc, char **argv )
{
    FILE  *infile;
    string line;
    int    line_number;

    if( argc != 2 ) {
        fprintf( stderr, "Usage: %s input-file\n", argv[0] );
        return 1;
    }

    if( ( infile = fopen( argv[1], "r" ) ) == NULL ) {
        fprintf( stderr, "Unable to open %s for reading.\n", argv[1] );
        return 1;
    }

    string_construct( &line );
    line_number = 1;
    while( string_readline( &line, infile ) != -1 ) {
        string result_line;
        string_construct( &result_line );
        
        string_copyf( &result_line, "%4d: ", line_number++ );
        string_append( &result_line, &line );
        string_writeline( &result_line, stdout );
        
        string_destroy( &result_line );
    }
    string_destroy( &line );

    fclose( infile );
    return 0;
}
